#! /bin/bash

## PROGRAM TO TEST THE LINK WITH MGEN4
# PARAMETERS TO BE CONFIGURED BY THE USER

port=7000                                      # port to use
address=10.0.0.51                              # destination address   
addr="$address:$port" 
loginName=cpg@tarantula
binDirectory=~/mgen4/mgen     # directory where the mgen executables are placed (mgenTest.sh, mgen, mgen6, drec, drec6, mcalc, mcalc6)
resultsDirectory=/tmp/cpg/aux
#~/mgen4/aux			# directory where the results are to be placed (it must exist)
maximumBandwidth=10				# maximum bandwidth that will be tested, in Mbps. For a 100 Mbps Ethernet, it may be 100

testDuration=1     # duration of each experiment

inter_tx=eth2  # Interface to transmit packets 
inter_rx=eth2  # Interface to receive packets

# END OF THE PARAMETERS TO BE CONFIGURED BY THE USER


sal=1
pruebas=0
contador=0
num_paquetes=0
incr_paquetes=0
ancho_b=0
  

   ssh $loginName rm $resultsDirectory/rate_tmp
   ssh $loginName rm $resultsDirectory/drops_tmp
   ssh $loginName rm $resultsDirectory/jitter_tmp
   ssh $loginName rm $resultsDirectory/val_tmp
   ssh $loginName rm $resultsDirectory/delay_tmp
 
   ssh $loginName rm $resultsDirectory/delay.txt
   ssh $loginName rm $resultsDirectory/drop.txt 
   ssh $loginName rm $resultsDirectory/flow.txt
   ssh $loginName rm $resultsDirectory/rate.txt
   ssh $loginName rm $resultsDirectory/jitter.txt
   ssh $loginName rm $resultsDirectory/test.txt
   ssh $loginName rm $resultsDirectory/sendingRate.txt
   ssh $loginName rm $resultsDirectory/maxDelay.txt
 
   ssh $loginName "cd $resultsDirectory; echo '1 '| cat > flow.txt"
   ssh $loginName "cd $resultsDirectory; echo '0 '| cat > val_tmp"




#############################################
##         PACKET SIZE = 1460
#############################################

 incr_paquetes=$(((maximumBandwidth*1000000)/(20*1460*8)))

while let  $((contador<20))

 do

   contador=$((contador+1))  
   num_paquetes=$((num_paquetes+incr_paquetes))
   ancho_b=$((ancho_b+((maximumBandwidth*1000)/20)))
   ssh $loginName "cd $resultsDirectory; echo $ancho_b| cat >> sendingRate.txt"   
   while let $sal==1
 
   do 
  
   ssh $loginName $binDirectory/./drec -p $port -i $inter_rx salida &
  ./mgen -b $addr -r $num_paquetes -s 1460 -d $testDuration $inter_tx

   ssh $loginName killall -2 $binDirectory/./drec

   ssh $loginName  $binDirectory/./mcalc salida $resultsDirectory

    sal=$?  
    echo "SALIDA2 "  $sal
    pruebas=$((pruebas+1))

   done
  
    ssh $loginName "cd $resultsDirectory; echo $pruebas| cat >> test.txt"
 
    ssh $loginName rm $resultsDirectory/rate_tmp
    ssh $loginName rm $resultsDirectory/drops_tmp
    ssh $loginName rm $resultsDirectory/jitter_tmp
    ssh $loginName rm $resultsDirectory/val_tmp
    ssh $loginName rm $resultsDirectory/delay_tmp

  
    ssh $loginName "cd $resultsDirectory; echo '0 '| cat > val_tmp"

    echo "****************************************"
    echo "NUMBER OF TESTS DONE" $pruebas 
    echo "****************************************"
    
    echo "****************************************"
    echo "BANDWIDTH (kbps)" $ancho_b
    echo "***************************************"

    echo "****************************************"
    echo "TEST WITH PACKET SIZE: 1460 BYTES"
    echo "****************************************"



    sal=1 
    pruebas=0

  done

    ssh $loginName "cd $resultsDirectory; echo '****************'| cat >> test.txt"
    ssh $loginName "cd $resultsDirectory; echo '*****************'| cat >> sendingRate.txt"
  
    num_paquetes=0
    ancho_b=0
    contador=0

